
template <class T>
class Map_t
{
public:
	int x_size, y_size; // Map size
	T** data;
	T* operator[](int i) { return data[i]; }
	
	bool initiated;
	Map_t() { initiated = false; };
	void init(int xSize, int ySize, T defaultVal);
	void reset(T val);
	bool set(int xx, int yy, T val);
	bool isvalid(int xx, int yy);
	~Map_t();
	
	Map_t<T>& operator=(const Map_t<T>& m);
	const Map_t<T> operator+(const Map_t<T>& m) const;
	Map_t<T>& operator+=(const Map_t<T>& m);
	
};


template <class T>
void Map_t<T>::init(int xSize, int ySize, T defaultVal)
{
	data = new T* [xSize];
	for (int xx = 0; xx < xSize; xx++)
	{
		data[xx] = new T [ySize];
		for (int yy = 0; yy < ySize; yy++)
			data[xx][yy] = defaultVal;
	}
	x_size = xSize;
	y_size = ySize;
	
	initiated = true;
}

template <class T>
void Map_t<T>::reset(T val)
{
	for (int xx = 0; xx < x_size; xx++)
		for (int yy = 0; yy < y_size; yy++)
			data[xx][yy] = val;
}

template <class T>
bool Map_t<T>::set(int xx, int yy, T val)
{
	if (xx<0 || yy<0 || xx>=x_size || yy>=y_size)
		return (false);
	else
	{
		data[xx][yy] = val;
		return (true);
	}
}

template <class T>
bool Map_t<T>::isvalid(int xx, int yy)
{
	if (xx<0 || yy<0 || xx>=x_size || yy>=y_size)
		return (false);
	else
		return (true);
}

template <class T>
Map_t<T>::~Map_t()
{
	if (initiated)
	{
		for (int xx = 0; xx < x_size; xx++)
			delete[] data[xx];
		delete[] data;
	}
}

// ------------------------------------------------
// Interface with OpenCV
/*
Map_t<int> cvGrayscaleImage2Map(IplImage* img, int chanel=0)
{
    Map_t<int> tmp_map;
    tmp_map.init(img.width, img.height, 0);
    for (int a=0; a<img.width; a++)
        for (int b=0; b<img.height; b++)
            tmp_map.data[a][b] = ((uchar *)(img->imageData + b*img->widthStep))[a];
}*/

// ------------------------------------------------
// Operators = , + , += , - , -= , * , *= , / , /=

/*
template <class T>
Map_t<T>& Map_t<T>::operator=(const Map_t<T>& m)
{
	if (this != &m)
	{
		if (x_size != m.x_size || y_size != m.y_size) // reallocate if size are different
		{
			for (int xx = 0; xx < x_size; xx++)
				delete[] data[xx];
			delete[] data;
			initiated = false;
		}
	
		x_size = m.x_size;
		y_size = m.y_size;
		
		if (!initiated)
		{
			data = new T* [x_size];
		    for (int xx = 0; xx < x_size; xx++)
		    	data[xx] = new T [y_size];
		}
		
		for (int xx = 0; xx < x_size; xx++)
			for (int yy = 0; yy < y_size; yy++)
				data[xx][yy] = m.data[xx][yy];
        
        initiated = true;
	}

	return *this;
}

// ++++++++++++++++++++++

template <class T>
const Map_t<T> Map_t<T>::operator+(const Map_t<T> &m) const
{
	Map_t<T> result;
	
	if (x_size != m.x_size || y_size != m.y_size)
		return result; // The addition is not possible
	
	result.x_size = x_size;
	result.y_size = y_size;
	result.data = new T* [x_size];
	for (int xx = 0; xx < x_size; xx++)
	{
		result.data[xx] = new T [y_size];
		for (int yy = 0; yy < y_size; yy++)
			result.data[xx][yy] = data[xx][yy] + m.data[xx][yy];
	}
	
	result.initiated = true;
	return result;
}

template <class T>
Map_t<T>& Map_t<T>::operator+=(const Map_t<T>& m)
{
	if (!initiated || x_size != m.x_size || y_size != m.y_size)
		return *this; // The addition is not possible
	
	for (int xx = 0; xx < x_size; xx++)
		for (int yy = 0; yy < y_size; yy++)
			data[xx][yy] += m.data[xx][yy];
	
	return *this;
}
*/

